#pragma once
#include "stdafx.h"
#include "cv.h"
#include <vector>
class GTCamera
{

public:
	GTCamera(void);
	GTCamera(const GTCamera &_cam);
public:
	~GTCamera(void);
public:
	static CvPoint3D64f right_eye_gaze;
	static CvPoint3D64f right_eye_center;
	static CvPoint3D64f left_eye_gaze;
	static CvPoint3D64f left_eye_center;
	static CvPoint3D64f gaze_focus;//the 3 dimensional point the user is looking at

	static CvPoint3D64f reference_gaze_focus;//the point parsed from the .pov file
	static CvPoint3D64f non_modified_gaze_focus;//the 1st solution of the algorithm without any parameter pertuberations

	static std::vector<plane> gazeplanes;

	IplImage *DarkFrame;
	IplImage *BrightFrame;
	IplImage *work;
	bool darkframeglintdetection;
	void *Lucam;//handle to the camera via the lucamapi
	double fx,fy,cx,cy; //focal length and principal point in pixel units
	double **rotation;//the rotation matrix FROM the local coordinate system TO the global coordinate system i.e. R^-1 in the pinhole camera model
	double **rotation_apriori;//the rotation matrix we get from a camera calibration
	double *translation;//the translation vector FROM the local coordinate system TO the global coordinate system i.e. -t in the pinhole camera model
	CvPoint3D64f camera_position;//position of the camera in 3d coordinates = LED0
	CvPoint3D64f LED1_position;//position of the LED1 in 3d coordinates
	
	CvRect left_eye_ROI;//this is the area around the pupil, where the glints should be.
	CvRect right_eye_ROI;

	std::vector<plane> left_eye_planes;//these are the planes constructed from Camera position, LED position and reflection spot.
	std::vector<plane> right_eye_planes;
	
	CvPoint2D64f left_eye_pupil;
	CvPoint2D64f right_eye_pupil;

	/*CvPoint3D64f cam_to_right_eye_pupil;
	CvPoint3D64f cam_to_left_eye_pupil;
	CvPoint3D64f cam_to_right_eye_center;
	CvPoint3D64f cam_to_left_eye_center;*/
	void load_calib_data(char *_filename);
	void calculate_focal_dist(double _angle);
	void load_position_data(char *_filename);

	//for debugging purposes
	CvPoint3D64f cam_to_glint1,cam_to_glint2,cam_to_glint3,cam_to_pupil;

};
