/*
*		This Code Was Created By Jeff Molofee 2000
*		A HUGE Thanks To Fredric Echols For Cleaning Up
*		And Optimizing This Code, Making It More Flexible!
*		If You've Found This Code Useful, Please Let Me Know.
*		Visit My Site At nehe.gamedev.net
*/

#include "stdafx.h"
#include <windows.h>		// Header File For Windows
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library
#include "opengl.h"
#include "algebra.h"
#include "GTCamera.h"

std::vector<GTCamera> *cams_;
bool *writelock;


#include <windowsx.h>		// Header File For LPARAM macro
HDC			hDC=NULL;		// Private GDI Device Context
HGLRC		hRC=NULL;		// Permanent Rendering Context
HWND		hWnd=NULL;		// Holds Our Window Handle
HINSTANCE	hInstance;		// Holds The Instance Of The Application

bool	keys[256];			// Array Used For The Keyboard Routine
bool	active=TRUE;		// Window Active Flag Set To TRUE By Default
bool	fullscreen=FALSE;	// Fullscreen Flag Set To No Fullscreen Mode By Default

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc

double      center_[3];//3-dimensional center of the scene
float       radius_;
GLdouble    projection_matrix_[16],
modelview_matrix_[16];
double  last_point_2D_[2];
double   last_point_3D_[3];
bool    last_point_ok_;
int width_;
int height_;

//draws a cube around _center with height=depth=width = 2*_expand
void draw_cubes(CvPoint3D64f &_center,double _expand)
{
	//specify the corners of the cubes
	//TLF = Top Left Near
	//BRF = Bottom Right Far etc.
	double TLN[3],TLF[3],BLN[3],BLF[3],
		TRN[3],TRF[3],BRN[3],BRF[3];
	TLN[0] = _center.x - _expand;
	TLN[1] = _center.y + _expand;
	TLN[2] = _center.z + _expand;
	TLF[0] = _center.x - _expand;
	TLF[1] = _center.y + _expand;
	TLF[2] = _center.z - _expand;
	BLN[0] = _center.x - _expand;
	BLN[1] = _center.y - _expand;
	BLN[2] = _center.z + _expand;
	BLF[0] = _center.x - _expand;
	BLF[1] = _center.y - _expand;
	BLF[2] = _center.z - _expand;
	TRN[0] = _center.x + _expand;
	TRN[1] = _center.y + _expand;
	TRN[2] = _center.z + _expand;
	TRF[0] = _center.x + _expand;
	TRF[1] = _center.y + _expand;
	TRF[2] = _center.z - _expand;
	BRN[0] = _center.x + _expand;
	BRN[1] = _center.y - _expand;
	BRN[2] = _center.z + _expand;
	BRF[0] = _center.x + _expand;
	BRF[1] = _center.y - _expand;
	BRF[2] = _center.z - _expand;


	//specify the quads with vertices in CCW order
	glBegin(GL_QUADS);						    
	glVertex3dv(TLN);
	glVertex3dv(BLN);	
	glVertex3dv(BLF);
	glVertex3dv(TLF);

	glVertex3dv(TLF);
	glVertex3dv(BLF);	
	glVertex3dv(BRF);
	glVertex3dv(TRF);

	glVertex3dv(BLN);
	glVertex3dv(BRN);	
	glVertex3dv(BRF);
	glVertex3dv(BLF);

	glVertex3dv(TRN);
	glVertex3dv(BRN);	
	glVertex3dv(BRF);
	glVertex3dv(TRF);

	glVertex3dv(TLN);
	glVertex3dv(TRN);	
	glVertex3dv(TRF);
	glVertex3dv(TLF);

	glVertex3dv(TLN);
	glVertex3dv(BLN);	
	glVertex3dv(BRN);
	glVertex3dv(TRN);

	glEnd();


}
void draw_planes()
{

	CvPoint3D64f vec1,vec2,eye_center;
	double TL[3],TR[3],BL[3],BR[3];
	plane planes[6];	

	std::vector<plane>::iterator it;

	*writelock=true;
	if (GTCamera::gazeplanes.size()>0)
		memcpy(planes,&GTCamera::gazeplanes[0],GTCamera::gazeplanes.size()*sizeof(plane));
	for(int i=0; i < 6;i++)
	{
		CrossProduct(cvPoint3D64f(0,1,0),cvPoint3D64f(planes[i].n_x,planes[i].n_y,planes[i].n_z),vec1);
		double length = sqrt(pow(vec1.x,2) + pow(vec1.y,2) + pow(vec1.z,2));
		vec1.x/=length;
		vec1.y/=length;
		vec1.z/=length;
		CrossProduct(cvPoint3D64f(planes[i].n_x,planes[i].n_y,planes[i].n_z),vec1,vec2);
		length = sqrt(pow(vec2.x,2) + pow(vec2.y,2) + pow(vec2.z,2));
		vec2.x/=length;
		vec2.y/=length;
		vec2.z/=length;

		if (i%2==0) memcpy(&eye_center,&GTCamera::left_eye_center,sizeof(CvPoint3D64f));
		if (i%2==1) memcpy(&eye_center,&GTCamera::right_eye_center,sizeof(CvPoint3D64f));
		TL[0]=eye_center.x - 1000*vec1.x - 1000*vec2.x;
		TL[1]=eye_center.y - 1000*vec1.y - 1000*vec2.y;
		TL[2]=eye_center.z - 1000*vec1.z - 1000*vec2.z;

		TR[0]=eye_center.x + 1000*vec1.x - 1000*vec2.x;
		TR[1]=eye_center.y + 1000*vec1.y - 1000*vec2.y;
		TR[2]=eye_center.z + 1000*vec1.z - 1000*vec2.z;

		BL[0]=eye_center.x - 1000*vec1.x + 1000*vec2.x;
		BL[1]=eye_center.y - 1000*vec1.y + 1000*vec2.y;
		BL[2]=eye_center.z - 1000*vec1.z + 1000*vec2.z;

		BR[0]=eye_center.x + 1000*vec1.x + 1000*vec2.x;
		BR[1]=eye_center.y + 1000*vec1.y + 1000*vec2.y;
		BR[2]=eye_center.z + 1000*vec1.z + 1000*vec2.z;
		glBegin(GL_LINE_STRIP);
		glVertex3dv(TL);
		glVertex3dv(BL);
		glVertex3dv(BR);
		glVertex3dv(TR);
		glVertex3dv(TL);
		glEnd();
	}
	*writelock=false;

}

//draws the camera and LED positions as cubes.
//we assume that we have 2 cameras and that cams_ is already initialized
void draw_static_positions()
{
	GLfloat white[] = {0.1, 0.1, .1, 1.0};
	GLfloat red[] = {1.0, 0.0, 0.0, 1.0};
	GLfloat blue[] = {0.0, 0.0, 1.0, 1.0};

	if( !(*cams_)[0].darkframeglintdetection)
	{
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, red);
	}
	else glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, white);
	draw_cubes((*cams_)[0].camera_position,50);

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, red);
	draw_cubes((*cams_)[0].LED1_position,50);

	draw_planes();
	
#if POVRAYIMG
	draw_cubes(cvPoint3D64f(100,237,50),50);
	draw_cubes(cvPoint3D64f(550,237,50),50);
	draw_cubes(GTCamera::reference_gaze_focus,50);
#else
	draw_cubes(cvPoint3D64f(300,200,-50),12);
	draw_cubes(cvPoint3D64f(360,200,-50),12);

#endif
	//to test rotation matrices..

	//GLfloat	material[] = {1.0, 0.0, 0.0, 1.0};
	//GLfloat	blue[] = {0.0, 0.0, 1.0, 1.0};
	//glGetMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,material);
	////draw the front in blue
	//glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,blue);
	//
	//GLfloat a[]={0.0,0,0.0f};
	//GLfloat b[]={0.4,0,0.0f};
	//GLfloat c[]={0.2,1,0.0f};

	//GLfloat d[]={0.1,0.1,0};
	//GLfloat e[]={0.1,0.1,1};
	//
	//GLfloat rota[]={0.0,0.2,0.0f};
	//GLfloat rotb[]={0.0,0.2,0.0f};
	//GLfloat rotc[]={0.0,0.2,0.0f};
	//GLfloat rotd[]={0.1,0.2,0.0f};
	//GLfloat rote[]={0.0,0.2,0.0f};

	//rota[0] = a[0] * (*cams_)[0].rotation[0][0] + a[1] * (*cams_)[0].rotation[0][1];
	//rota[1] = a[0] * (*cams_)[0].rotation[1][0] + a[1] * (*cams_)[0].rotation[1][1];
	//rota[2] = a[0] * (*cams_)[0].rotation[2][0] + a[1] * (*cams_)[0].rotation[2][1];

	//rotb[0] = b[0] * (*cams_)[0].rotation[0][0] + b[1] * (*cams_)[0].rotation[0][1];
	//rotb[1] = b[0] * (*cams_)[0].rotation[1][0] + b[1] * (*cams_)[0].rotation[1][1];
	//rotb[2] = b[0] * (*cams_)[0].rotation[2][0] + b[1] * (*cams_)[0].rotation[2][1];

	//rotc[0] = c[0] * (*cams_)[0].rotation[0][0] + c[1] * (*cams_)[0].rotation[0][1];
	//rotc[1] = c[0] * (*cams_)[0].rotation[1][0] + c[1] * (*cams_)[0].rotation[1][1];
	//rotc[2] = c[0] * (*cams_)[0].rotation[2][0] + c[1] * (*cams_)[0].rotation[2][1];

	//rotd[0] = d[0] * (*cams_)[0].rotation[0][0] + d[1] * (*cams_)[0].rotation[0][1];
	//rotd[1] = d[0] * (*cams_)[0].rotation[1][0] + d[1] * (*cams_)[0].rotation[1][1];
	//rotd[2] = d[0] * (*cams_)[0].rotation[2][0] + d[1] * (*cams_)[0].rotation[2][1];
	//
	//rote[0] = e[0] * (*cams_)[0].rotation[0][0] + e[1] * (*cams_)[0].rotation[0][1] + e[2] * (*cams_)[0].rotation[0][2];
	//rote[1] = e[0] * (*cams_)[0].rotation[1][0] + e[1] * (*cams_)[0].rotation[1][1] + e[2] * (*cams_)[0].rotation[1][2];
	//rote[2] = e[0] * (*cams_)[0].rotation[2][0] + e[1] * (*cams_)[0].rotation[2][1] + e[2] * (*cams_)[0].rotation[2][2];


	//glBegin(GL_TRIANGLES);
	//glVertex3fv(rota);
	//glVertex3fv(rotb);
	//glVertex3fv(rotc);
	//glEnd();
	//glBegin(GL_LINES);
	//glVertex3fv(rotd);
	//glVertex3fv(rote);
	//glEnd();
	//   
	//glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,material);






	if( !(*cams_)[1].darkframeglintdetection)
	{
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, red);
	}
	else glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, white);
	draw_cubes((*cams_)[1].camera_position,50);

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, red);
	draw_cubes((*cams_)[1].LED1_position,50);

	if( !(*cams_)[2].darkframeglintdetection)
	{
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, red);
	}
	else glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, white);
	draw_cubes((*cams_)[2].camera_position,50);

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, red);
	draw_cubes((*cams_)[2].LED1_position,50);
	//draw rays from camera to the eye

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, white);


	glBegin(GL_LINES);
	glVertex3d(GTCamera::right_eye_center.x,GTCamera::right_eye_center.y,GTCamera::right_eye_center.z);
	glVertex3d((*cams_)[0].camera_position.x,(*cams_)[0].camera_position.y,(*cams_)[0].camera_position.z);

	glVertex3d(GTCamera::right_eye_center.x,GTCamera::right_eye_center.y,GTCamera::right_eye_center.z);
	glVertex3d((*cams_)[1].camera_position.x,(*cams_)[1].camera_position.y,(*cams_)[1].camera_position.z);

	glVertex3d(GTCamera::right_eye_center.x,GTCamera::right_eye_center.y,GTCamera::right_eye_center.z);
	glVertex3d((*cams_)[2].camera_position.x,(*cams_)[2].camera_position.y,(*cams_)[2].camera_position.z);

	glVertex3d(GTCamera::left_eye_center.x,GTCamera::left_eye_center.y,GTCamera::left_eye_center.z);
	glVertex3d((*cams_)[0].camera_position.x,(*cams_)[0].camera_position.y,(*cams_)[0].camera_position.z);

	glVertex3d(GTCamera::left_eye_center.x,GTCamera::left_eye_center.y,GTCamera::left_eye_center.z);
	glVertex3d((*cams_)[1].camera_position.x,(*cams_)[1].camera_position.y,(*cams_)[1].camera_position.z);

	glVertex3d(GTCamera::left_eye_center.x,GTCamera::left_eye_center.y,GTCamera::left_eye_center.z);
	glVertex3d((*cams_)[2].camera_position.x,(*cams_)[2].camera_position.y,(*cams_)[2].camera_position.z);

	glEnd();

	//draw the gaze direction;
	glBegin(GL_LINES);
	glVertex3d(GTCamera::right_eye_center.x,GTCamera::right_eye_center.y,GTCamera::right_eye_center.z);
	glVertex3d(GTCamera::right_eye_center.x+3*GTCamera::right_eye_gaze.x,
		GTCamera::right_eye_center.y+3*GTCamera::right_eye_gaze.y,
		GTCamera::right_eye_center.z+3*GTCamera::right_eye_gaze.z);

	glVertex3d(GTCamera::left_eye_center.x,GTCamera::left_eye_center.y,GTCamera::left_eye_center.z);
	glVertex3d(GTCamera::left_eye_center.x+3*GTCamera::left_eye_gaze.x,
		GTCamera::left_eye_center.y+3*GTCamera::left_eye_gaze.y,
		GTCamera::left_eye_center.z+3*GTCamera::left_eye_gaze.z);

	glEnd();

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, red);
	glBegin(GL_LINES);

	for(int i=0;i<(*cams_).size();i++)
	{
	
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, red);
		glVertex3d((*cams_)[i].camera_position.x,(*cams_)[i].camera_position.y,(*cams_)[i].camera_position.z);
		glVertex3d((*cams_)[i].camera_position.x+1200*(*cams_)[i].cam_to_glint1.x,(*cams_)[i].camera_position.y+1200*(*cams_)[i].cam_to_glint1.y,(*cams_)[i].camera_position.z+1200*(*cams_)[i].cam_to_glint1.z);

		glVertex3d((*cams_)[i].camera_position.x,(*cams_)[i].camera_position.y,(*cams_)[i].camera_position.z);
		glVertex3d((*cams_)[i].camera_position.x+1200*(*cams_)[i].cam_to_glint2.x,(*cams_)[i].camera_position.y+1200*(*cams_)[i].cam_to_glint2.y,(*cams_)[i].camera_position.z+1200*(*cams_)[i].cam_to_glint2.z);
	
		glVertex3d((*cams_)[i].camera_position.x,(*cams_)[i].camera_position.y,(*cams_)[i].camera_position.z);
		glVertex3d((*cams_)[i].camera_position.x+1200*(*cams_)[i].cam_to_glint3.x,(*cams_)[i].camera_position.y+1200*(*cams_)[i].cam_to_glint3.y,(*cams_)[i].camera_position.z+1200*(*cams_)[i].cam_to_glint3.z);
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, blue);
	
		glVertex3d((*cams_)[i].camera_position.x,(*cams_)[i].camera_position.y,(*cams_)[i].camera_position.z);
		glVertex3d((*cams_)[i].camera_position.x+1200*(*cams_)[i].cam_to_pupil.x,(*cams_)[i].camera_position.y+1200*(*cams_)[i].cam_to_pupil.y,(*cams_)[i].camera_position.z+1200*(*cams_)[i].cam_to_pupil.z);
	}
	glEnd();
}
void rotate( double _axis[3], float _angle )
{
	// Rotate around center center_, axis _axis, by angle _angle
	// Update modelview_matrix_

	double t[3];
	t[0] = (modelview_matrix_[0]*center_[0] + 
		modelview_matrix_[4]*center_[1] +
		modelview_matrix_[8]*center_[2] + 
		modelview_matrix_[12]);
	t[1] = (modelview_matrix_[1]*center_[0] + 
		modelview_matrix_[5]*center_[1] +
		modelview_matrix_[9]*center_[2] + 
		modelview_matrix_[13]);
	t[2] = (modelview_matrix_[2]*center_[0] + 
		modelview_matrix_[6]*center_[1] +
		modelview_matrix_[10]*center_[2] + 
		modelview_matrix_[14]);

	glLoadIdentity();
	glTranslatef(t[0], t[1], t[2]);
	glRotated( _angle, _axis[0], _axis[1], _axis[2]);
	glTranslatef(-t[0], -t[1], -t[2]); 
	glMultMatrixd(modelview_matrix_);
	glGetDoublev(GL_MODELVIEW_MATRIX, modelview_matrix_);
}
bool map_to_sphere( double _v2D[2], double _v3D[3] )
{
	if ( (_v2D[0] >= 0) && (_v2D[0] <= width_) &&
		(_v2D[1] >= 0) && (_v2D[1] <= height_) ) 
	{
		double x  = (double)(_v2D[0] - 0.5*width_)  / (double)width_;	// -> [-0.5, +0.5]
		double y  = (double)(0.5*height_ - _v2D[1]) / (double)height_;	// -> [-0.5, +0.5]

		double sinx         = sin(3.1415927 * x * 0.5);
		double siny         = sin(3.1415927 * y * 0.5);
		double sinx2siny2   = sinx * sinx + siny * siny;

		_v3D[0] = sinx;
		_v3D[1] = siny;
		_v3D[2] = sinx2siny2 < 1.0 ? sqrt(1.0 - sinx2siny2) : 0.0;

		return true;
	}
	else return false;
}
void translate( double _trans[3] )
{
	// Translate the object by _trans
	// Update modelview_matrix_

	glLoadIdentity();
	glTranslated( _trans[0], _trans[1], _trans[2] );
	glMultMatrixd( modelview_matrix_ );
	glGetDoublev( GL_MODELVIEW_MATRIX, modelview_matrix_);

}
void view_all()
{  
	double transvec[3];
	transvec[0] = -(modelview_matrix_[0]*center_[0] + 
		modelview_matrix_[4]*center_[1] +
		modelview_matrix_[8]*center_[2] + 
		modelview_matrix_[12]);
	transvec[1] = -(modelview_matrix_[1]*center_[0] + 
		modelview_matrix_[5]*center_[1] +
		modelview_matrix_[9]*center_[2] + 
		modelview_matrix_[13]);
	transvec[2] = -(modelview_matrix_[2]*center_[0] + 
		modelview_matrix_[6]*center_[1] +
		modelview_matrix_[10]*center_[2] + 
		modelview_matrix_[14] +
		3.0*radius_);// Moving by 3*radius_ of the scene
	translate(transvec);	
}
void update_projection_matrix()
{
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();

	gluPerspective(
		45.0, (GLfloat) width_ / (GLfloat) height_,
		0.01*radius_, 1000.0*radius_);
	glGetDoublev( GL_PROJECTION_MATRIX, projection_matrix_);
	glMatrixMode( GL_MODELVIEW );
}
void set_scene_pos( double _cog[3], float _radius )
{
	memcpy(center_,_cog,sizeof(double)*3);

	radius_ = _radius;
	update_projection_matrix();
	view_all();
}

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport
	width_ = width;
	height_ = height;
	update_projection_matrix();
}

int InitGL(GLvoid)										// All Setup For OpenGL Goes Here
{
	// OpenGL state
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glDisable( GL_DITHER );
	glEnable( GL_DEPTH_TEST );


	// material
	GLfloat mat_a[] = {0.2, 0.2, 0.2, 1.0};
	GLfloat mat_d[] = {0.4, 0.4, 0.4, 1.0};
	GLfloat mat_s[] = {0.8, 0.8, 0.8, 1.0};
	GLfloat shine[] = {128.0};
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,   mat_a);
	/*glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE,   mat_d);
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR,  mat_s);*/
	glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, shine);


	// lighting
	glLoadIdentity();

	GLfloat pos1[] = { 0.1, 0.1, -0.02, 0.0};
	GLfloat pos2[] = {-0.1, 0.1, -0.02, 0.0};
	GLfloat pos3[] = { 0.0, 0.0, 0.1, 0.0};
	GLfloat col1[] = {.05, .05, .6, 1.0};
	GLfloat col2[] = {.6, .05, .05, 1.0};
	GLfloat col3[] = {1.0, 1.0, 1.0, 1.0};

	glEnable(GL_LIGHT0);    
	glLightfv(GL_LIGHT0,GL_POSITION, pos1);
	glLightfv(GL_LIGHT0,GL_DIFFUSE,  col1);
	glLightfv(GL_LIGHT0,GL_SPECULAR, col1);

	glEnable(GL_LIGHT1);  
	glLightfv(GL_LIGHT1,GL_POSITION, pos2);
	glLightfv(GL_LIGHT1,GL_DIFFUSE,  col2);
	glLightfv(GL_LIGHT1,GL_SPECULAR, col2);

	glEnable(GL_LIGHT2);  
	glLightfv(GL_LIGHT2,GL_POSITION, pos3);
	glLightfv(GL_LIGHT2,GL_DIFFUSE,  col3);
	glLightfv(GL_LIGHT2,GL_SPECULAR, col3);


	// scene pos and size
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glGetDoublev(GL_MODELVIEW_MATRIX, modelview_matrix_);
	double center[3];
	memset(center,0,sizeof(double)*3);
	set_scene_pos(center, 100.0);
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	
	return TRUE;										
}

int DrawGLScene(GLvoid)									// Here's Where We Do All The Drawing
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glMatrixMode( GL_PROJECTION );
	glLoadMatrixd( projection_matrix_ );
	glMatrixMode( GL_MODELVIEW );
	glLoadMatrixd( modelview_matrix_ );
	glEnable(GL_LIGHTING);
	glShadeModel(GL_SMOOTH);
	//draw the camera and LEDS
	draw_static_positions();
	return TRUE;										// Everything Went OK
}

GLvoid KillGLWindow(GLvoid)								// Properly Kill The Window
{
	if (fullscreen)										// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);					// If So Switch Back To The Desktop
		ShowCursor(TRUE);								// Show Mouse Pointer
	}

	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Are We Able To Release The DC And RC Contexts?
		{
			MessageBoxW(NULL,_T("Release Of DC And RC Failed."),_T("SHUTDOWN ERROR"),MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Are We Able To Delete The RC?
		{
			MessageBox(NULL,_T("Release Rendering Context Failed."),_T("SHUTDOWN ERROR"),MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Are We Able To Release The DC
	{
		MessageBox(NULL,_T("Release Device Context Failed."),_T("SHUTDOWN ERROR"),MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,_T("Could Not Release hWnd."),_T("SHUTDOWN ERROR"),MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Set hWnd To NULL
	}

	if (!UnregisterClass(_T("OpenGL"),hInstance))			// Are We Able To Unregister Class
	{
		MessageBox(NULL,_T("Could Not Unregister Class."),_T("SHUTDOWN ERROR"),MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									// Set hInstance To NULL
	}
}

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
*	title			- Title To Appear At The Top Of The Window				*
*	width			- Width Of The GL Window Or Fullscreen Mode				*
*	height			- Height Of The GL Window Or Fullscreen Mode			*
*	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
*	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/

BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	WNDCLASS	wc;						// Windows Class Structure
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)width;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= _T("OpenGL");								// Set The Class Name

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,_T("Failed To Register The Window Class."),_T("ERROR"),MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,_T("The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?"),_T("NeHe GL"),MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;		// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,_T("Program Will Now Close."),_T("ERROR"),MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
		ShowCursor(FALSE);										// Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Adjust Window To True Requested Size


	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
		_T("OpenGL"),							// Class Name
		_T("OpenGLWindow"),								// Window Title //TODO use char *title
		dwStyle |							// Defined Window Style
		WS_CLIPSIBLINGS |					// Required Window Style
		WS_CLIPCHILDREN,					// Required Window Style
		0, 0,								// Window Position
		WindowRect.right-WindowRect.left,	// Calculate Window Width
		WindowRect.bottom-WindowRect.top,	// Calculate Window Height
		NULL,								// No Parent Window
		NULL,								// No Menu
		hInstance,							// Instance
		NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,_T("Window Creation Error."),_T("ERROR"),MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		bits,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};

	if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,_T("Can't Create A GL Device Context."),_T("ERROR"),MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,_T("Can't Find A Suitable PixelFormat."),_T("ERROR"),MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,_T("Can't Set The PixelFormat."),_T("ERROR"),MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,_T("Can't Create A GL Rendering Context."),_T("ERROR"),MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,_T("Can't Activate The GL Rendering Context."),_T("ERROR"),MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// Show The Window
	SetForegroundWindow(hWnd);						// Slightly Higher Priority
	SetFocus(hWnd);									// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);					// Set Up Our Perspective GL Screen

	if (!InitGL())									// Initialize Our Newly Created GL Window
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,_T("Initialization Failed."),_T("ERROR"),MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	return TRUE;									// Success
}

LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle For This Window
						 UINT	uMsg,			// Message For This Window
						 WPARAM	wParam,			// Additional Message Information
						 LPARAM	lParam)			// Additional Message Information
{
	switch (uMsg)									// Check For Windows Messages
	{
	case WM_ACTIVATE:							// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))					// Check Minimization State
			{
				active=TRUE;						// Program Is Active
			}
			else
			{
				active=FALSE;						// Program Is No Longer Active
			}

			return 0;								// Return To The Message Loop
		}

	case WM_SYSCOMMAND:							// Intercept System Commands
		{
			switch (wParam)							// Check System Calls
			{
			case SC_SCREENSAVE:					// Screensaver Trying To Start?
			case SC_MONITORPOWER:				// Monitor Trying To Enter Powersave?
				return 0;							// Prevent From Happening
			}
			break;									// Exit
		}

	case WM_CLOSE:								// Did We Receive A Close Message?
		{
			PostQuitMessage(0);						// Send A Quit Message
			return 0;								// Jump Back
		}

	case WM_KEYDOWN:							// Is A Key Being Held Down?
		{
			keys[wParam] = TRUE;					// If So, Mark It As TRUE
			return 0;								// Jump Back
		}

	case WM_KEYUP:								// Has A Key Been Released?
		{
			keys[wParam] = FALSE;					// If So, Mark It As FALSE
			return 0;								// Jump Back
		}

	case WM_SIZE:								// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Width, HiWord=Height
			return 0;								// Jump Back
		}
	case WM_LBUTTONDOWN:						// Remember point
		{
			last_point_2D_[0] = GET_X_LPARAM(lParam); 
			last_point_2D_[1] = GET_Y_LPARAM(lParam); 

			last_point_ok_ = map_to_sphere( last_point_2D_,
				last_point_3D_ );
			return 0;
		}
	case WM_MOUSEMOVE:
		{
			double newPoint2D[2];
			newPoint2D[0] = GET_X_LPARAM(lParam);
			newPoint2D[1] = GET_Y_LPARAM(lParam);
			if ( (newPoint2D[0]<0) || (newPoint2D[0]>width_) ||
				(newPoint2D[0]<0) || (newPoint2D[1]>height_) ) return 0;

			float       value_y;
			double   newPoint3D[3];
			bool        newPoint_hitSphere = map_to_sphere( newPoint2D, newPoint3D );

			float dx = newPoint2D[0] - last_point_2D_[0];
			float dy = newPoint2D[1] - last_point_2D_[1];

			float w  = width_;
			float h  = height_;


			// right button: zoom in/out
			//-------------------------------------------------------- move in z direction

			if (wParam & MK_RBUTTON)
			{
				value_y = radius_ * dy * 3.0 / h;
				double transvec[3];
				transvec[0] = 0.0;
				transvec[1] = 0.0;
				transvec[2] = 20*value_y;//multiply by 20 for faster zoom
				translate(transvec);
			}

			//Left button: rotate around center_		
			else if (wParam & MK_LBUTTON)
			{
				double axis[3];
				float angle=0;

				if (last_point_ok_) 
				{
					if (newPoint_hitSphere = map_to_sphere(newPoint2D, newPoint3D)) 
					{
						//axis is crossproduct of the two
						axis[0] = last_point_3D_[1] * newPoint3D[2] - last_point_3D_[2] * newPoint3D[1];
						axis[1] = last_point_3D_[2] * newPoint3D[0] - last_point_3D_[0] * newPoint3D[2];
						axis[2] = last_point_3D_[0] * newPoint3D[1] - last_point_3D_[1] * newPoint3D[0];

						float cos_angle = (last_point_3D_[0] * newPoint3D[0]) + (last_point_3D_[1] * newPoint3D[1]) + (last_point_3D_[2] * newPoint3D[2]);
						if ( fabs(cos_angle) < 1.0 ) 
						{
							angle = acos( cos_angle ) * 180.0 / 3.1415927;
							angle *= 2.0;
						}
					}
				}
				rotate( axis, angle );
			}


			// Middle button: translate object
			else if(wParam & MK_MBUTTON)
			{
				//------------------------------------------------------ move in x,y direction
				float z = - (modelview_matrix_[ 2]*center_[0] + 
					modelview_matrix_[ 6]*center_[1] + 
					modelview_matrix_[10]*center_[2] + 
					modelview_matrix_[14]) /
					(modelview_matrix_[ 3]*center_[0] + 
					modelview_matrix_[ 7]*center_[1] + 
					modelview_matrix_[11]*center_[2] + 
					modelview_matrix_[15]);

				float fovy   = 45.0f;
				float aspect = w / h;
				float fnear   = 0.01 * radius_;
				float top    = tan(fovy/2.0f*3.1415927/180.f) * fnear;
				float right  = aspect*top;

				double transvec[3];
				transvec[0] = 2.0*dx/w*right/fnear*z;
				transvec[1] =  -2.0*dy/h*top/fnear*z;
				transvec[2] = 0.0;
				translate(transvec);
			}


			//remember this point
			memcpy(last_point_2D_,newPoint2D,sizeof(double)*2);
			memcpy(last_point_3D_,newPoint3D,sizeof(double)*2);
			last_point_ok_ = newPoint_hitSphere;



			return 0;
		}
	case WM_LBUTTONUP:
		{
			last_point_ok_ = false;
			return 0;
		}
	}

	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}


DWORD WINAPI GlMain(LPVOID _data)
{

	bool *kill = &((sync_struct*) _data)->killthread;//kill is used to synchronize the threads.. as soon as the mainprogram is finished, kill is set to true and this thread will stop running
	cams_ = ((sync_struct*) _data)->cams;
	writelock = &((sync_struct*) _data)->writelock;
	MSG		msg;									// Windows Message Structure
	BOOL	done=FALSE;								// Bool Variable To Exit Loop

	// Ask The User Which Screen Mode They Prefer
	//if (MessageBox(NULL,_T("Would You Like To Run In Fullscreen Mode?"),_T("Start FullScreen?"),MB_YESNO|MB_ICONQUESTION)==IDNO)
	//{
	//	fullscreen=FALSE;							// Windowed Mode
	//}

	// Create Our OpenGL Window
	if (!CreateGLWindow("NeHe's OpenGL Framework",640,480,16,fullscreen))
	{
		return 0;									// Quit If Window Was Not Created
	}

	while((!done)&&(!*kill))									// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)				// Have We Received A Quit Message?
			{
				done=TRUE;							// If So done=TRUE
			}
			else									// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);				// Translate The Message
				DispatchMessage(&msg);				// Dispatch The Message
			}
		}
		else										// If There Are No Messages
		{
			// Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
			if (active)								// Program Active?
			{
				if(keys[VK_SPACE])
				{
					view_all();

				}
				if(keys[VK_UP])
				{
					(*cams_)[0].fx+=10;
					(*cams_)[0].fy+=10;
					(*cams_)[1].fx+=10;
					(*cams_)[1].fy+=10;
					(*cams_)[2].fx+=10;
					(*cams_)[2].fy+=10;
					keys[VK_UP]=false;
				}
				if(keys[VK_DOWN])
				{
					(*cams_)[0].fx-=3;
					(*cams_)[0].fy-=3;
					(*cams_)[1].fx-=3;
					(*cams_)[1].fy-=3;
					(*cams_)[2].fx-=3;
					(*cams_)[2].fy-=3;
					keys[VK_DOWN]=false;
				}
				if (keys[VK_ESCAPE])				// Was ESC Pressed?
				{
					done=TRUE;						// ESC Signalled A Quit
				}
				else								// Not Time To Quit, Update Screen
				{
					DrawGLScene();					// Draw The Scene
					SwapBuffers(hDC);				// Swap Buffers (Double Buffering)
				}
				if (keys[VK_F1])						// Is F1 Being Pressed?
				{
					keys[VK_F1]=FALSE;					// If So Make Key FALSE
					KillGLWindow();						// Kill Our Current Window
					fullscreen=!fullscreen;				// Toggle Fullscreen / Windowed Mode
					// Recreate Our OpenGL Window
					if (!CreateGLWindow("NeHe's OpenGL Framework",640,480,16,fullscreen))
					{
						return 0;						// Quit If Window Was Not Created
					}
				}
			}
		}
	}

	// Shutdown
	KillGLWindow();									// Kill The Window
	return (msg.wParam);							// Exit The Program
}
