
#include "glass.inc"     

#include "metals.inc"

 //be careful not to change the format, or the .pov file may get read wrong by the c++ program     
 
#declare direction_=<0,0,-1>;              
#declare cam0=<960.804,141.406,758.063>;
#declare rot0=<3.040380,40.264380,-3.649950>;
#declare angle0=15;  
#declare led0=<702,411,878>;                                   
                                  
  
#declare cam1=<-299.431,155.921,712.009>; 
#declare rot1=<1.015830,-40.963140,4.908870>;
#declare angle1=18;
#declare led1=<-130,411,878>;

#declare cam2=<247.914,614.469,1007.486>;   
#declare rot2=<-23.529330,-3.454470,0.260730>;
#declare angle2=10;              
#declare led2=<307,-216,777>;
                     
#declare focus=<550,100,847>;
#declare eye1=<250,237,50>;
#declare eye2=<350,237,50>;     
      
//cam0 

#switch(clock)
#range(0,1)   //0DARK


camera {
   location <0,0,0> 
   direction direction_             
     rotate rot0
     translate cam0
     angle angle0   
     }  
     

light_source{led0 color rgb <1,1,1> }
light_source{led1 color rgb <1,1,1> }
light_source{led2 color rgb <1,1,1> }

 #declare eye_primitive2 = 
sphere { <0, 0, 0>, 1.2 texture {pigment{color rgb<1,1,1>}
               finish { phong 0 diffuse 0 phong_size 500 }
 }}
 
 
#break
#range(1,2)   //0BRIGHT


camera {
   location <0,0,0> 
   direction direction_  
  //  right right_*x 
      rotate rot0
     translate cam0
     angle angle0
  
     }  
light_source{cam0 color rgb <1,1,1> }
light_source{cam1 color rgb <1,1,1> }
light_source{cam2 color rgb <1,1,1> }   

 #declare eye_primitive2 = 
sphere { <0, 0, 0>, 1.2 texture {pigment{color rgb<1,1,1>}
               finish { phong 0 diffuse 1 phong_size 500 }
 }}
 
#break
#range(2,3)    //1DARK
        

 
camera {   
    location <0,0,0>   
     direction direction_  
   // right right_*x           
      rotate rot1
     translate cam1
     angle angle1
 } 
light_source{led0 color rgb <1,1,1> }
light_source{led1 color rgb <1,1,1> }
light_source{led2 color rgb <1,1,1> }
   
 #declare eye_primitive2 = 
sphere { <0, 0, 0>, 1.2 texture {pigment{color rgb<1,1,1>}
               finish { phong 0 diffuse 0 phong_size 500 }
 }}
#break
#range(3,4)        //1Bright

camera {   
    location <0,0,0> 
     direction direction_  
  //  right right_*x            
      rotate rot1
     translate cam1
     angle angle1
 } 
light_source{cam0 color rgb <1,1,1> }
light_source{cam1 color rgb <1,1,1> }
light_source{cam2 color rgb <1,1,1> }   
   
 #declare eye_primitive2 = 
sphere { <0, 0, 0>, 1.2 texture {pigment{color rgb<1,1,1>}
               finish { phong 0 diffuse 1 phong_size 500 }
 }}
 #break
 #range(4,5)   //2DARK

camera {   
    location <0,0,0>   
     direction direction_  
 //   right right_*x            
     rotate rot2
     translate cam2
     angle angle2
 }   
light_source{led0 color rgb <1,1,1> }
light_source{led1 color rgb <1,1,1> }
light_source{led2 color rgb <1,1,1> }
  
 #declare eye_primitive2 = 
sphere { <0, 0, 0>, 1.2 texture {pigment{color rgb<1,1,1>}
               finish { phong 0 diffuse 0 phong_size 500 }
 }}

   
#break
#range(5,6) //2BRIGHT
 
camera {   
    location <0,0,0>                    
     direction direction_  
  //  right right_*x              
     rotate rot2
     translate cam2
     angle angle2
 }   
light_source{cam0 color rgb <1,1,1> }
light_source{cam1 color rgb <1,1,1> }
light_source{cam2 color rgb <1,1,1> }   

 #declare eye_primitive2 = 
sphere { <0, 0, 0>, 1.2 texture {pigment{color rgb<1,1,1>}
               finish { phong 0 diffuse 1 phong_size 500 }
 }}

 #break
 #end            
 
sky_sphere {
    pigment {
        gradient <0,1,0>
        color_map { [0.00 rgb <0.6,0.7,1.0>]
                    [0.35 rgb <0.0,0.1,0.8>]
                    [0.65 rgb <0.0,0.1,0.8>]
                    [1.00 rgb <0.6,0.7,1.0>]
                  }
                scale 2
            } // end of pigment
           } //end of skysphere -----------
 

#declare n1=-vcross(<0,0,1>,(focus-eye1)/vlength(focus-eye1));
#declare ang1=-degrees(acos(-vdot(<0,0,1>,(focus-eye1)/vlength(focus-eye1))));    
#declare x1=-vcross(<0,1,0>,(focus-eye1)/vlength(focus-eye1))/vlength(vcross(<0,1,0>,(focus-eye1)/vlength(focus-eye1)));
#declare y1=-vcross(x1,(focus-eye1)/vlength(focus-eye1))   /vlength(vcross(x1,(focus-eye1)/vlength(focus-eye1)));
#declare z1=vcross(x1,y1)/ vlength( vcross(x1,y1));

#declare x2=-vcross(<0,1,0>,(focus-eye2)/vlength(focus-eye2))/vlength(vcross(<0,1,0>,(focus-eye2)/vlength(focus-eye2)));
#declare y2=-vcross(x2,(focus-eye2)/vlength(focus-eye2))/vlength(vcross(x2,(focus-eye2)/vlength(focus-eye2)));
#declare z2=vcross(x2,y2)/vlength( vcross(x2,y2));

#declare eye_primitive = sphere { <0, 0, 0>, 1.2 texture {pigment{color rgb<0.6,0.6,0.6>}
               finish { phong 0 diffuse 0.2 phong_size 500}
 }}     

              
                   
        
#declare cyl= cylinder {<0,0,0> <0,0,2> 0.2 texture {pigment{color rgb<0.1,0.1,0.1>}
               finish { phong 0 diffuse 0.2 phong_size 500
 }  }             }
   

//the aqueous humor
                   
#declare aqe = sphere
{ <0,0,0.8>,0.6
  pigment { rgbf <0.5,0.9,1,0.95> } // A blue-tinted glass
  finish
  { phong 0.9 phong_size 400  // A highlight
    reflection 0.0  // Glass reflects a bit
  }
  interior
  { ior 1.33 // Glass refraction
  }
}
#declare eye=
        union{   
          object{aqe}  
        difference{
        object{ eye_primitive}
        object{ cyl} 
        }    
        intersection{
        object{ eye_primitive2}
        object{ cyl} 
        }
         
              

        }
        
//object{pupil}
//object{pupil translate <50,0,0>}
 //     object{eye} 
/*
object{eye matrix<cos(ang1)+((1-cos(ang1))*n1.x*n1.x),
                  ((1-cos(ang1))*n1.x*n1.y) + sin(ang1)*n1.z,
                  ((1-cos(ang1))*n1.x*n1.z) - sin(ang1)*n1.y, 
                  
                  ((1-cos(ang1))*n1.x*n1.y) - sin(ang1)*n1.z,
                  cos(ang1)+((1-cos(ang1))*n1.y*n1.y),
                  ((1-cos(ang1))*n1.y*n1.z) + sin(ang1)*n1.x,
                  
                  ((1-cos(ang1))*n1.x*n1.z) + sin(ang1)*n1.y,
                  ((1-cos(ang1))*n1.y*n1.z) - sin(ang1)*n1.x,
                  cos(ang1)+((1-cos(ang1))*n1.z*n1.z),0,0,0>
                  
                  
                 
                  translate eye1}     
                  
                  */    
//object{eye translate eye1}
object{eye  matrix<x1.x, y1.x, z1.x, x1.y,y1.y,z1.y,x1.z,y1.z,z1.z,0,0,0> scale 20 translate eye1}//scale 10 would be physically correct
object{eye matrix<x2.x, y2.x, z2.x, x2.y,y2.y,z2.y,x2.z,y2.z,z2.z,0,0,0> scale 20 translate eye2}
  
  
//object{eye scale 100 translate eye1}
//object{eye scale 100 translate eye2}
